/*

Alloc - A garbage collecting memory allocator.

*/

#ifndef Alloc_Defn
#define Alloc_Defn

void* malloc( unsigned Length );
/*
malloc returns a block of memory <Length> bytes in size.  It returns
NULL when no block of size <Length> can be returned.  If the system
runs low on memory, it will perform a garbage collection to reclaim
previously allocated blocks which are no longer referenced.  The
reclaimed blocks are available to be used for allocations.
*/

void free( void* Ptr );

#endif

